<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright 2007 XBRL International. All Rights Reserved. -->
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:case="http://xbrl.org/2005/conformance"
  xmlns:eg="http://xbrl.org/2005/example">
  <xsl:template match="documentation">
    <html>
      <head>
        <title>
          <xsl:value-of select="@name" />
        </title>
      </head>
      <body>
        <h1>
          <xsl:value-of select="@name" />
          :
          <xsl:value-of select="@date" />
        </h1>
        <xsl:apply-templates select="testcases" />
        <xsl:apply-templates select="examples" />
      </body>
    </html>
  </xsl:template>
  
  <xsl:template match="testcases">
    <h2>Test cases (to be provided as the specification becomes more stable)</h2>
    <table border="0">
      <tbody>
        <tr>
          <td colspan="3">
            <xsl:value-of select="@name" />
          </td>
          <td colspan="3">
            <xsl:value-of select="@date" />
          </td>
        </tr>
        <tr>
          <td colspan="2"></td>
        </tr>
        <tr>
          <th>Variations</th>
          <th>Name</th>
          <th>Owner</th>
          <th>Description</th>
        </tr>
        <!-- now just generate one row per test set -->
        <xsl:apply-templates select="testcase" />
      </tbody>
    </table>
  </xsl:template>
  
  <xsl:template match="examples">
    <h2>Examples</h2>
    <table border="0">
      <tbody>
        <tr>
          <td colspan="3">
            <xsl:value-of select="@name" />
          </td>
          <td colspan="3">
            <xsl:value-of select="@date" />
          </td>
        </tr>
        <tr>
          <td colspan="2"></td>
        </tr>
        <tr>
          <th>Variations</th>
          <th>Name</th>
          <th>Owner</th>
          <th>Description</th>
        </tr>
        <!-- now just generate one row per test set -->
        <xsl:apply-templates select="example" />
      </tbody>
    </table>
  </xsl:template>
  
  <xsl:template match="testcase">
    <xsl:variable name="uri" select="@uri" />
    <xsl:variable name="case" select="document($uri)/case:testcase" />
    <xsl:variable name="variations" select="$case/case:variation" />
    <tr>
      <td align="right">
        <xsl:value-of select="count($variations)" />
      </td>
      <td>
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="$uri" />
          </xsl:attribute>
          <xsl:value-of select="$case/@name" />
        </xsl:element>
      </td>
      <td>
        <xsl:element name="a">
          <xsl:attribute name="href">
            mailto:
            <xsl:value-of select="$case/@owner" />
          </xsl:attribute>
          <xsl:value-of select="$case/@owner" />
        </xsl:element>
      </td>
      <td>
        <xsl:value-of select="$case/@description" />
      </td>
    </tr>
  </xsl:template>
  
  <xsl:template match="example">
    <xsl:variable name="uri" select="@uri" />
    <xsl:variable name="example" select="document($uri)/eg:example" />
    <xsl:variable name="variations" select="$example/eg:variation" />
    <tr>
      <td align="right">
        <xsl:value-of select="count($variations)" />
      </td>
      <td>
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="$uri" />
          </xsl:attribute>
          <xsl:value-of select="$example/@name" />
        </xsl:element>
      </td>
      <td>
        <xsl:element name="a">
          <xsl:attribute name="href">
            mailto:
            <xsl:value-of select="$example/@owner" />
          </xsl:attribute>
          <xsl:value-of select="$example/@owner" />
        </xsl:element>
      </td>
      <td>
        <xsl:value-of select="$example/@description" />
      </td>
    </tr>
  </xsl:template>
  
</xsl:stylesheet>
